Fix status check
[osm/tests.git] / robot-systest / run_test.sh
1 #!/usr/bin/env bash
2
3 ##
4 # Copyright 2020 ATOS
5 #
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License");
9 # you may not use this file except in compliance with the License.
10 # You may obtain a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS,
16 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
17 # See the License for the specific language governing permissions and
18 # limitations under the License.
19 ##
20
21 cat /dev/zero | ssh-keygen -q -N "" > /dev/null
22
23 install_osmclient(){
24 echo -e "\nInstalling osmclient ${OSMCLIENT}"
25 python3 -m pip install git+https://osm.etsi.org/gerrit/osm/osmclient@${OSMCLIENT}
26 }
27
28 download_packages(){
29 echo -e "\nDownloading packages ${PACKAGES}"
30 rm -rf ${PACKAGES_FOLDER}
31 git clone https://osm.etsi.org/gitlab/vnf-onboarding/osm-packages.git ${PACKAGES_FOLDER} && (cd ${PACKAGES_FOLDER} && \
32 git checkout sol006)
33 }
34
35 download_tst010(){
36 # Fetch conformance tests
37 git clone --single-branch --branch ${NFV_TESTS_BRANCH} https://forge.etsi.org/rep/nfv/api-tests.git /robot-systest/conformance-tests/repo
38 python3 -m pip install -r /robot-systest/conformance-tests/repo/requirements.txt
39 }
40
41 create_vim(){
42
43 attempts=3
44 while [ $attempts -ge 0 ] ; do
45 echo -e "\n$( date '+%F_%H:%M:%S' ) Creating VIM ${VIM_TARGET}"
46 osm vim-create --name ${VIM_TARGET} --user ${OS_USERNAME} --password ${OS_PASSWORD} --tenant ${OS_PROJECT_NAME} \
47 --auth_url ${OS_AUTH_URL} --account_type openstack --description vim \
48 --config "{management_network_name: ${VIM_MGMT_NET}, dataplane_physical_net: ${DATAPLANE:-physnet2}}" || true
49 STATUS=""
50 i=0
51 while [[ ${STATUS} != "ENABLED" ]]
52 do
53 ((i++))
54 if [[ $i -eq 5 ]]; then
55 echo "VIM stuck for more than 50 seconds as: ${VIM_LIST}"
56 osm vim-delete --force ${VIM_TARGET}
57 sleep 5
58 break
59 fi
60 sleep 10
61 VIM_LIST=`osm vim-list --long | grep ${VIM_TARGET}`
62 echo VIM status: ${VIM_LIST}
63 STATUS=`echo ${VIM_LIST} | grep -io ENABLED`
64 done
65 if [[ ${STATUS} = "ENABLED" ]] ; then
66 break
67 fi
68 ((attempts--))
69 done
70 if [ $attempts -lt 0 ] ; then
71 echo "VIM failed to enter ENABLED state"
72 exit 1
73 fi
74 }
75
76
77 PARAMS=""
78 RUN_CONFORMANCE_TESTS=false
79
80 while (( "$#" )); do
81 case "$1" in
82 -t|--testingtags)
83 TEST=$2
84 shift 2
85 ;;
86 -p|--packagesbranch)
87 PACKAGES=$2 && download_packages
88 shift 2
89 ;;
90 -o|--osmclientversion)
91 OSMCLIENT=$2 && install_osmclient
92 shift 2
93 ;;
94 -c|--createvim)
95 create_vim
96 shift 1
97 ;;
98 -T)
99 NFV_TESTS_BRANCH=$2 && download_tst010
100 RUN_CONFORMANCE_TESTS=true
101 shift 1
102 ;;
103 -h|--help)
104 echo "OSM TESTS TOOL
105
106 Usage:
107 docker run --rm=true -t osmtests --env-file <env_file> \\
108 -v <path_to_reports>:/reports osmtests \\
109 -v <path_to_clouds.yaml>:/robot-systest/clouds.yaml \\
110 -v <path_to_kubeconfig>:/root/.kube/config \\
111 -o <osmclient_version> \\
112 -p <package_branch> \\
113 -t <testing_tags>
114
115 Options:
116 --env-file: It is the environmental file where is described the OSM target and VIM
117 -o <osmclient_version> [OPTIONAL]: It is used to specify a particular osmclient version. Default: latest
118 -p <package_branch> [OPTIONAL]: OSM packages repository branch. Default: master
119 -t <testing_tags> [OPTIONAL]: Robot tests tags. [sanity, regression, particular_test]. Default: sanity
120 -T <testing_branch> [OPTIONAL]: Run SOL005 Robot conformance tests
121 -c To create a VIM for the tests
122
123 Volumes:
124 <path_to_reports> [OPTIONAL]: It is the absolute path to reports location in the host
125 <path_to_clouds.yaml> [OPTIONAL]: It is the absolute path to the clouds.yaml file in the host
126 <path_to_kubeconfig> [OPTIONAL]: It is the kubeconfig file to be used for k8s clusters"
127
128 exit 0
129 ;;
130 -*|--*=)
131 echo "Error: Unsupported flag $1" >&2
132 exit 1
133 ;;
134 *)
135 PARAMS="$PARAMS $1"
136 shift
137 ;;
138 esac
139 done
140
141 eval set -- "$PARAMS"
142
143 if [[ -n "$BRANCH_NAME" ]]; then
144 PACKAGES=$BRANCH_NAME && download_packages
145 OSMCLIENT=$BRANCH_NAME && install_osmclient
146 fi
147
148
149 if [ "$RUN_CONFORMANCE_TESTS" = true ] ; then
150 python3 ${ROBOT_DEVOPS_FOLDER}/conformance-tests/run_conformance_tests.py
151 fi
152
153 if [[ -z "${TEST}" ]]; then
154 printf "Test not provided. \nRunning default test: sanity\n"
155 TEST="sanity"
156 fi
157
158 if [[ -n "${TEST}" ]]; then
159 robot -d ${ROBOT_DEVOPS_FOLDER}/reports -i ${TEST} ${ROBOT_DEVOPS_FOLDER}/testsuite/
160 exit 0
161 else
162 echo "Wrong test provided"
163 exit 1
164 fi
165
166 exit 1